Index: /branches/version-2_11-dev/data/module/fpdf/tutorial/makefont.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/tutorial/makefont.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/tutorial/makefont.php	(revision 20993)
@@ -0,0 +1,6 @@
+<?php
+// Generation of font definition file for tutorial 7
+require('../makefont/makefont.php');
+
+MakeFont('calligra.ttf','cp1252');
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto1.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto1.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto1.php	(revision 20993)
@@ -0,0 +1,9 @@
+<?php
+require('../fpdf.php');
+
+$pdf = new FPDF();
+$pdf->AddPage();
+$pdf->SetFont('Arial','B',16);
+$pdf->Cell(40,10,'Hello World!');
+$pdf->Output();
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto2.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto2.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto2.php	(revision 20993)
@@ -0,0 +1,41 @@
+<?php
+require('../fpdf.php');
+
+class PDF extends FPDF
+{
+// Page header
+function Header()
+{
+	// Logo
+	$this->Image('logo.png',10,6,30);
+	// Arial bold 15
+	$this->SetFont('Arial','B',15);
+	// Move to the right
+	$this->Cell(80);
+	// Title
+	$this->Cell(30,10,'Title',1,0,'C');
+	// Line break
+	$this->Ln(20);
+}
+
+// Page footer
+function Footer()
+{
+	// Position at 1.5 cm from bottom
+	$this->SetY(-15);
+	// Arial italic 8
+	$this->SetFont('Arial','I',8);
+	// Page number
+	$this->Cell(0,10,'Page '.$this->PageNo().'/{nb}',0,0,'C');
+}
+}
+
+// Instanciation of inherited class
+$pdf = new PDF();
+$pdf->AliasNbPages();
+$pdf->AddPage();
+$pdf->SetFont('Times','',12);
+for($i=1;$i<=40;$i++)
+	$pdf->Cell(0,10,'Printing line number '.$i,0,1);
+$pdf->Output();
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/tutorial/calligra.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/tutorial/calligra.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/tutorial/calligra.php	(revision 20993)
@@ -0,0 +1,23 @@
+<?php
+$type = 'TrueType';
+$name = 'CalligrapherRegular';
+$desc = array('Ascent'=>899,'Descent'=>-234,'CapHeight'=>899,'Flags'=>32,'FontBBox'=>'[-173 -234 1328 899]','ItalicAngle'=>0,'StemV'=>70,'MissingWidth'=>800);
+$up = -200;
+$ut = 20;
+$cw = array(
+	chr(0)=>800,chr(1)=>800,chr(2)=>800,chr(3)=>800,chr(4)=>800,chr(5)=>800,chr(6)=>800,chr(7)=>800,chr(8)=>800,chr(9)=>800,chr(10)=>800,chr(11)=>800,chr(12)=>800,chr(13)=>800,chr(14)=>800,chr(15)=>800,chr(16)=>800,chr(17)=>800,chr(18)=>800,chr(19)=>800,chr(20)=>800,chr(21)=>800,
+	chr(22)=>800,chr(23)=>800,chr(24)=>800,chr(25)=>800,chr(26)=>800,chr(27)=>800,chr(28)=>800,chr(29)=>800,chr(30)=>800,chr(31)=>800,' '=>282,'!'=>324,'"'=>405,'#'=>584,'$'=>632,'%'=>980,'&'=>776,'\''=>259,'('=>299,')'=>299,'*'=>377,'+'=>600,
+	','=>259,'-'=>432,'.'=>254,'/'=>597,'0'=>529,'1'=>298,'2'=>451,'3'=>359,'4'=>525,'5'=>423,'6'=>464,'7'=>417,'8'=>457,'9'=>479,':'=>275,';'=>282,'<'=>600,'='=>600,'>'=>600,'?'=>501,'@'=>800,'A'=>743,
+	'B'=>636,'C'=>598,'D'=>712,'E'=>608,'F'=>562,'G'=>680,'H'=>756,'I'=>308,'J'=>314,'K'=>676,'L'=>552,'M'=>1041,'N'=>817,'O'=>729,'P'=>569,'Q'=>698,'R'=>674,'S'=>618,'T'=>673,'U'=>805,'V'=>753,'W'=>1238,
+	'X'=>716,'Y'=>754,'Z'=>599,'['=>315,'\\'=>463,']'=>315,'^'=>600,'_'=>547,'`'=>278,'a'=>581,'b'=>564,'c'=>440,'d'=>571,'e'=>450,'f'=>347,'g'=>628,'h'=>611,'i'=>283,'j'=>283,'k'=>560,'l'=>252,'m'=>976,
+	'n'=>595,'o'=>508,'p'=>549,'q'=>540,'r'=>395,'s'=>441,'t'=>307,'u'=>614,'v'=>556,'w'=>915,'x'=>559,'y'=>597,'z'=>452,'{'=>315,'|'=>222,'}'=>315,'~'=>600,chr(127)=>800,chr(128)=>800,chr(129)=>800,chr(130)=>0,chr(131)=>0,
+	chr(132)=>0,chr(133)=>780,chr(134)=>0,chr(135)=>0,chr(136)=>278,chr(137)=>0,chr(138)=>0,chr(139)=>0,chr(140)=>1064,chr(141)=>800,chr(142)=>0,chr(143)=>800,chr(144)=>800,chr(145)=>259,chr(146)=>259,chr(147)=>470,chr(148)=>470,chr(149)=>500,chr(150)=>300,chr(151)=>600,chr(152)=>278,chr(153)=>990,
+	chr(154)=>0,chr(155)=>0,chr(156)=>790,chr(157)=>800,chr(158)=>800,chr(159)=>754,chr(160)=>282,chr(161)=>324,chr(162)=>450,chr(163)=>640,chr(164)=>518,chr(165)=>603,chr(166)=>0,chr(167)=>519,chr(168)=>254,chr(169)=>800,chr(170)=>349,chr(171)=>0,chr(172)=>0,chr(173)=>432,chr(174)=>800,chr(175)=>278,
+	chr(176)=>0,chr(177)=>0,chr(178)=>0,chr(179)=>0,chr(180)=>278,chr(181)=>614,chr(182)=>0,chr(183)=>254,chr(184)=>278,chr(185)=>0,chr(186)=>305,chr(187)=>0,chr(188)=>0,chr(189)=>0,chr(190)=>0,chr(191)=>501,chr(192)=>743,chr(193)=>743,chr(194)=>743,chr(195)=>743,chr(196)=>743,chr(197)=>743,
+	chr(198)=>1060,chr(199)=>598,chr(200)=>608,chr(201)=>608,chr(202)=>608,chr(203)=>608,chr(204)=>308,chr(205)=>308,chr(206)=>308,chr(207)=>308,chr(208)=>0,chr(209)=>817,chr(210)=>729,chr(211)=>729,chr(212)=>729,chr(213)=>729,chr(214)=>729,chr(215)=>0,chr(216)=>729,chr(217)=>805,chr(218)=>805,chr(219)=>805,
+	chr(220)=>805,chr(221)=>0,chr(222)=>0,chr(223)=>688,chr(224)=>581,chr(225)=>581,chr(226)=>581,chr(227)=>581,chr(228)=>581,chr(229)=>581,chr(230)=>792,chr(231)=>440,chr(232)=>450,chr(233)=>450,chr(234)=>450,chr(235)=>450,chr(236)=>283,chr(237)=>283,chr(238)=>283,chr(239)=>283,chr(240)=>0,chr(241)=>595,
+	chr(242)=>508,chr(243)=>508,chr(244)=>508,chr(245)=>508,chr(246)=>508,chr(247)=>0,chr(248)=>508,chr(249)=>614,chr(250)=>614,chr(251)=>614,chr(252)=>614,chr(253)=>0,chr(254)=>0,chr(255)=>597);
+$enc = 'cp1252';
+$file = 'calligra.z';
+$originalsize = 40120;
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto3.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto3.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto3.php	(revision 20993)
@@ -0,0 +1,81 @@
+<?php
+require('../fpdf.php');
+
+class PDF extends FPDF
+{
+function Header()
+{
+	global $title;
+
+	// Arial bold 15
+	$this->SetFont('Arial','B',15);
+	// Calculate width of title and position
+	$w = $this->GetStringWidth($title)+6;
+	$this->SetX((210-$w)/2);
+	// Colors of frame, background and text
+	$this->SetDrawColor(0,80,180);
+	$this->SetFillColor(230,230,0);
+	$this->SetTextColor(220,50,50);
+	// Thickness of frame (1 mm)
+	$this->SetLineWidth(1);
+	// Title
+	$this->Cell($w,9,$title,1,1,'C',true);
+	// Line break
+	$this->Ln(10);
+}
+
+function Footer()
+{
+	// Position at 1.5 cm from bottom
+	$this->SetY(-15);
+	// Arial italic 8
+	$this->SetFont('Arial','I',8);
+	// Text color in gray
+	$this->SetTextColor(128);
+	// Page number
+	$this->Cell(0,10,'Page '.$this->PageNo(),0,0,'C');
+}
+
+function ChapterTitle($num, $label)
+{
+	// Arial 12
+	$this->SetFont('Arial','',12);
+	// Background color
+	$this->SetFillColor(200,220,255);
+	// Title
+	$this->Cell(0,6,"Chapter $num : $label",0,1,'L',true);
+	// Line break
+	$this->Ln(4);
+}
+
+function ChapterBody($file)
+{
+	// Read text file
+	$txt = file_get_contents($file);
+	// Times 12
+	$this->SetFont('Times','',12);
+	// Output justified text
+	$this->MultiCell(0,5,$txt);
+	// Line break
+	$this->Ln();
+	// Mention in italics
+	$this->SetFont('','I');
+	$this->Cell(0,5,'(end of excerpt)');
+}
+
+function PrintChapter($num, $title, $file)
+{
+	$this->AddPage();
+	$this->ChapterTitle($num,$title);
+	$this->ChapterBody($file);
+}
+}
+
+$pdf = new PDF();
+$title = '20000 Leagues Under the Seas';
+$pdf->SetTitle($title);
+$pdf->SetAuthor('Jules Verne');
+$pdf->PrintChapter(1,'A RUNAWAY REEF','20k_c1.txt');
+$pdf->PrintChapter(2,'THE PROS AND CONS','20k_c2.txt');
+$pdf->Output();
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto4.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto4.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto4.php	(revision 20993)
@@ -0,0 +1,111 @@
+<?php
+require('../fpdf.php');
+
+class PDF extends FPDF
+{
+// Current column
+var $col = 0;
+// Ordinate of column start
+var $y0;
+
+function Header()
+{
+	// Page header
+	global $title;
+
+	$this->SetFont('Arial','B',15);
+	$w = $this->GetStringWidth($title)+6;
+	$this->SetX((210-$w)/2);
+	$this->SetDrawColor(0,80,180);
+	$this->SetFillColor(230,230,0);
+	$this->SetTextColor(220,50,50);
+	$this->SetLineWidth(1);
+	$this->Cell($w,9,$title,1,1,'C',true);
+	$this->Ln(10);
+	// Save ordinate
+	$this->y0 = $this->GetY();
+}
+
+function Footer()
+{
+	// Page footer
+	$this->SetY(-15);
+	$this->SetFont('Arial','I',8);
+	$this->SetTextColor(128);
+	$this->Cell(0,10,'Page '.$this->PageNo(),0,0,'C');
+}
+
+function SetCol($col)
+{
+	// Set position at a given column
+	$this->col = $col;
+	$x = 10+$col*65;
+	$this->SetLeftMargin($x);
+	$this->SetX($x);
+}
+
+function AcceptPageBreak()
+{
+	// Method accepting or not automatic page break
+	if($this->col<2)
+	{
+		// Go to next column
+		$this->SetCol($this->col+1);
+		// Set ordinate to top
+		$this->SetY($this->y0);
+		// Keep on page
+		return false;
+	}
+	else
+	{
+		// Go back to first column
+		$this->SetCol(0);
+		// Page break
+		return true;
+	}
+}
+
+function ChapterTitle($num, $label)
+{
+	// Title
+	$this->SetFont('Arial','',12);
+	$this->SetFillColor(200,220,255);
+	$this->Cell(0,6,"Chapter $num : $label",0,1,'L',true);
+	$this->Ln(4);
+	// Save ordinate
+	$this->y0 = $this->GetY();
+}
+
+function ChapterBody($file)
+{
+	// Read text file
+	$txt = file_get_contents($file);
+	// Font
+	$this->SetFont('Times','',12);
+	// Output text in a 6 cm width column
+	$this->MultiCell(60,5,$txt);
+	$this->Ln();
+	// Mention
+	$this->SetFont('','I');
+	$this->Cell(0,5,'(end of excerpt)');
+	// Go back to first column
+	$this->SetCol(0);
+}
+
+function PrintChapter($num, $title, $file)
+{
+	// Add chapter
+	$this->AddPage();
+	$this->ChapterTitle($num,$title);
+	$this->ChapterBody($file);
+}
+}
+
+$pdf = new PDF();
+$title = '20000 Leagues Under the Seas';
+$pdf->SetTitle($title);
+$pdf->SetAuthor('Jules Verne');
+$pdf->PrintChapter(1,'A RUNAWAY REEF','20k_c1.txt');
+$pdf->PrintChapter(2,'THE PROS AND CONS','20k_c2.txt');
+$pdf->Output();
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto5.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto5.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto5.php	(revision 20993)
@@ -0,0 +1,102 @@
+<?php
+require('../fpdf.php');
+
+class PDF extends FPDF
+{
+// Load data
+function LoadData($file)
+{
+	// Read file lines
+	$lines = file($file);
+	$data = array();
+	foreach($lines as $line)
+		$data[] = explode(';',trim($line));
+	return $data;
+}
+
+// Simple table
+function BasicTable($header, $data)
+{
+	// Header
+	foreach($header as $col)
+		$this->Cell(40,7,$col,1);
+	$this->Ln();
+	// Data
+	foreach($data as $row)
+	{
+		foreach($row as $col)
+			$this->Cell(40,6,$col,1);
+		$this->Ln();
+	}
+}
+
+// Better table
+function ImprovedTable($header, $data)
+{
+	// Column widths
+	$w = array(40, 35, 40, 45);
+	// Header
+	for($i=0;$i<count($header);$i++)
+		$this->Cell($w[$i],7,$header[$i],1,0,'C');
+	$this->Ln();
+	// Data
+	foreach($data as $row)
+	{
+		$this->Cell($w[0],6,$row[0],'LR');
+		$this->Cell($w[1],6,$row[1],'LR');
+		$this->Cell($w[2],6,number_format($row[2]),'LR',0,'R');
+		$this->Cell($w[3],6,number_format($row[3]),'LR',0,'R');
+		$this->Ln();
+	}
+	// Closing line
+	$this->Cell(array_sum($w),0,'','T');
+}
+
+// Colored table
+function FancyTable($header, $data)
+{
+	// Colors, line width and bold font
+	$this->SetFillColor(255,0,0);
+	$this->SetTextColor(255);
+	$this->SetDrawColor(128,0,0);
+	$this->SetLineWidth(.3);
+	$this->SetFont('','B');
+	// Header
+	$w = array(40, 35, 40, 45);
+	for($i=0;$i<count($header);$i++)
+		$this->Cell($w[$i],7,$header[$i],1,0,'C',true);
+	$this->Ln();
+	// Color and font restoration
+	$this->SetFillColor(224,235,255);
+	$this->SetTextColor(0);
+	$this->SetFont('');
+	// Data
+	$fill = false;
+	foreach($data as $row)
+	{
+		$this->Cell($w[0],6,$row[0],'LR',0,'L',$fill);
+		$this->Cell($w[1],6,$row[1],'LR',0,'L',$fill);
+		$this->Cell($w[2],6,number_format($row[2]),'LR',0,'R',$fill);
+		$this->Cell($w[3],6,number_format($row[3]),'LR',0,'R',$fill);
+		$this->Ln();
+		$fill = !$fill;
+	}
+	// Closing line
+	$this->Cell(array_sum($w),0,'','T');
+}
+}
+
+$pdf = new PDF();
+// Column headings
+$header = array('Country', 'Capital', 'Area (sq km)', 'Pop. (thousands)');
+// Data loading
+$data = $pdf->LoadData('countries.txt');
+$pdf->SetFont('Arial','',14);
+$pdf->AddPage();
+$pdf->BasicTable($header,$data);
+$pdf->AddPage();
+$pdf->ImprovedTable($header,$data);
+$pdf->AddPage();
+$pdf->FancyTable($header,$data);
+$pdf->Output();
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto6.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto6.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto6.php	(revision 20993)
@@ -0,0 +1,124 @@
+<?php
+require('../fpdf.php');
+
+class PDF extends FPDF
+{
+var $B;
+var $I;
+var $U;
+var $HREF;
+
+function PDF($orientation='P', $unit='mm', $size='A4')
+{
+	// Call parent constructor
+	$this->FPDF($orientation,$unit,$size);
+	// Initialization
+	$this->B = 0;
+	$this->I = 0;
+	$this->U = 0;
+	$this->HREF = '';
+}
+
+function WriteHTML($html)
+{
+	// HTML parser
+	$html = str_replace("\n",' ',$html);
+	$a = preg_split('/<(.*)>/U',$html,-1,PREG_SPLIT_DELIM_CAPTURE);
+	foreach($a as $i=>$e)
+	{
+		if($i%2==0)
+		{
+			// Text
+			if($this->HREF)
+				$this->PutLink($this->HREF,$e);
+			else
+				$this->Write(5,$e);
+		}
+		else
+		{
+			// Tag
+			if($e[0]=='/')
+				$this->CloseTag(strtoupper(substr($e,1)));
+			else
+			{
+				// Extract attributes
+				$a2 = explode(' ',$e);
+				$tag = strtoupper(array_shift($a2));
+				$attr = array();
+				foreach($a2 as $v)
+				{
+					if(preg_match('/([^=]*)=["\']?([^"\']*)/',$v,$a3))
+						$attr[strtoupper($a3[1])] = $a3[2];
+				}
+				$this->OpenTag($tag,$attr);
+			}
+		}
+	}
+}
+
+function OpenTag($tag, $attr)
+{
+	// Opening tag
+	if($tag=='B' || $tag=='I' || $tag=='U')
+		$this->SetStyle($tag,true);
+	if($tag=='A')
+		$this->HREF = $attr['HREF'];
+	if($tag=='BR')
+		$this->Ln(5);
+}
+
+function CloseTag($tag)
+{
+	// Closing tag
+	if($tag=='B' || $tag=='I' || $tag=='U')
+		$this->SetStyle($tag,false);
+	if($tag=='A')
+		$this->HREF = '';
+}
+
+function SetStyle($tag, $enable)
+{
+	// Modify style and select corresponding font
+	$this->$tag += ($enable ? 1 : -1);
+	$style = '';
+	foreach(array('B', 'I', 'U') as $s)
+	{
+		if($this->$s>0)
+			$style .= $s;
+	}
+	$this->SetFont('',$style);
+}
+
+function PutLink($URL, $txt)
+{
+	// Put a hyperlink
+	$this->SetTextColor(0,0,255);
+	$this->SetStyle('U',true);
+	$this->Write(5,$txt,$URL);
+	$this->SetStyle('U',false);
+	$this->SetTextColor(0);
+}
+}
+
+$html = 'You can now easily print text mixing different styles: <b>bold</b>, <i>italic</i>,
+<u>underlined</u>, or <b><i><u>all at once</u></i></b>!<br><br>You can also insert links on
+text, such as <a href="http://www.fpdf.org">www.fpdf.org</a>, or on an image: click on the logo.';
+
+$pdf = new PDF();
+// First page
+$pdf->AddPage();
+$pdf->SetFont('Arial','',20);
+$pdf->Write(5,"To find out what's new in this tutorial, click ");
+$pdf->SetFont('','U');
+$link = $pdf->AddLink();
+$pdf->Write(5,'here',$link);
+$pdf->SetFont('');
+// Second page
+$pdf->AddPage();
+$pdf->SetLink($link);
+$pdf->Image('logo.png',10,12,30,0,'','http://www.fpdf.org');
+$pdf->SetLeftMargin(45);
+$pdf->SetFontSize(14);
+$pdf->WriteHTML($html);
+$pdf->Output();
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto7.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto7.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/tutorial/tuto7.php	(revision 20993)
@@ -0,0 +1,11 @@
+<?php
+define('FPDF_FONTPATH','.');
+require('../fpdf.php');
+
+$pdf = new FPDF();
+$pdf->AddFont('Calligrapher','','calligra.php');
+$pdf->AddPage();
+$pdf->SetFont('Calligrapher','',35);
+$pdf->Cell(0,10,'Enjoy new fonts with FPDF!');
+$pdf->Output();
+?>
Index: /branches/version-2_11-dev/data/module/fpdf/makefont/ttfparser.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/makefont/ttfparser.php	(revision 20993)
+++ /branches/version-2_11-dev/data/module/fpdf/makefont/ttfparser.php	(revision 20993)
@@ -0,0 +1,289 @@
+<?php
+/*******************************************************************************
+* Utility to parse TTF font files                                              *
+*                                                                              *
+* Version: 1.0                                                                 *
+* Date:    2011-06-18                                                          *
+* Author:  Olivier PLATHEY                                                     *
+*******************************************************************************/
+
+class TTFParser
+{
+	var $f;
+	var $tables;
+	var $unitsPerEm;
+	var $xMin, $yMin, $xMax, $yMax;
+	var $numberOfHMetrics;
+	var $numGlyphs;
+	var $widths;
+	var $chars;
+	var $postScriptName;
+	var $Embeddable;
+	var $Bold;
+	var $typoAscender;
+	var $typoDescender;
+	var $capHeight;
+	var $italicAngle;
+	var $underlinePosition;
+	var $underlineThickness;
+	var $isFixedPitch;
+
+	function Parse($file)
+	{
+		$this->f = fopen($file, 'rb');
+		if(!$this->f)
+			$this->Error('Can\'t open file: '.$file);
+
+		$version = $this->Read(4);
+		if($version=='OTTO')
+			$this->Error('OpenType fonts based on PostScript outlines are not supported');
+		if($version!="\x00\x01\x00\x00")
+			$this->Error('Unrecognized file format');
+		$numTables = $this->ReadUShort();
+		$this->Skip(3*2); // searchRange, entrySelector, rangeShift
+		$this->tables = array();
+		for($i=0;$i<$numTables;$i++)
+		{
+			$tag = $this->Read(4);
+			$this->Skip(4); // checkSum
+			$offset = $this->ReadULong();
+			$this->Skip(4); // length
+			$this->tables[$tag] = $offset;
+		}
+
+		$this->ParseHead();
+		$this->ParseHhea();
+		$this->ParseMaxp();
+		$this->ParseHmtx();
+		$this->ParseCmap();
+		$this->ParseName();
+		$this->ParseOS2();
+		$this->ParsePost();
+
+		fclose($this->f);
+	}
+
+	function ParseHead()
+	{
+		$this->Seek('head');
+		$this->Skip(3*4); // version, fontRevision, checkSumAdjustment
+		$magicNumber = $this->ReadULong();
+		if($magicNumber!=0x5F0F3CF5)
+			$this->Error('Incorrect magic number');
+		$this->Skip(2); // flags
+		$this->unitsPerEm = $this->ReadUShort();
+		$this->Skip(2*8); // created, modified
+		$this->xMin = $this->ReadShort();
+		$this->yMin = $this->ReadShort();
+		$this->xMax = $this->ReadShort();
+		$this->yMax = $this->ReadShort();
+	}
+
+	function ParseHhea()
+	{
+		$this->Seek('hhea');
+		$this->Skip(4+15*2);
+		$this->numberOfHMetrics = $this->ReadUShort();
+	}
+
+	function ParseMaxp()
+	{
+		$this->Seek('maxp');
+		$this->Skip(4);
+		$this->numGlyphs = $this->ReadUShort();
+	}
+
+	function ParseHmtx()
+	{
+		$this->Seek('hmtx');
+		$this->widths = array();
+		for($i=0;$i<$this->numberOfHMetrics;$i++)
+		{
+			$advanceWidth = $this->ReadUShort();
+			$this->Skip(2); // lsb
+			$this->widths[$i] = $advanceWidth;
+		}
+		if($this->numberOfHMetrics<$this->numGlyphs)
+		{
+			$lastWidth = $this->widths[$this->numberOfHMetrics-1];
+			$this->widths = array_pad($this->widths, $this->numGlyphs, $lastWidth);
+		}
+	}
+
+	function ParseCmap()
+	{
+		$this->Seek('cmap');
+		$this->Skip(2); // version
+		$numTables = $this->ReadUShort();
+		$offset31 = 0;
+		for($i=0;$i<$numTables;$i++)
+		{
+			$platformID = $this->ReadUShort();
+			$encodingID = $this->ReadUShort();
+			$offset = $this->ReadULong();
+			if($platformID==3 && $encodingID==1)
+				$offset31 = $offset;
+		}
+		if($offset31==0)
+			$this->Error('No Unicode encoding found');
+
+		$startCount = array();
+		$endCount = array();
+		$idDelta = array();
+		$idRangeOffset = array();
+		$this->chars = array();
+		fseek($this->f, $this->tables['cmap']+$offset31, SEEK_SET);
+		$format = $this->ReadUShort();
+		if($format!=4)
+			$this->Error('Unexpected subtable format: '.$format);
+		$this->Skip(2*2); // length, language
+		$segCount = $this->ReadUShort()/2;
+		$this->Skip(3*2); // searchRange, entrySelector, rangeShift
+		for($i=0;$i<$segCount;$i++)
+			$endCount[$i] = $this->ReadUShort();
+		$this->Skip(2); // reservedPad
+		for($i=0;$i<$segCount;$i++)
+			$startCount[$i] = $this->ReadUShort();
+		for($i=0;$i<$segCount;$i++)
+			$idDelta[$i] = $this->ReadShort();
+		$offset = ftell($this->f);
+		for($i=0;$i<$segCount;$i++)
+			$idRangeOffset[$i] = $this->ReadUShort();
+
+		for($i=0;$i<$segCount;$i++)
+		{
+			$c1 = $startCount[$i];
+			$c2 = $endCount[$i];
+			$d = $idDelta[$i];
+			$ro = $idRangeOffset[$i];
+			if($ro>0)
+				fseek($this->f, $offset+2*$i+$ro, SEEK_SET);
+			for($c=$c1;$c<=$c2;$c++)
+			{
+				if($c==0xFFFF)
+					break;
+				if($ro>0)
+				{
+					$gid = $this->ReadUShort();
+					if($gid>0)
+						$gid += $d;
+				}
+				else
+					$gid = $c+$d;
+				if($gid>=65536)
+					$gid -= 65536;
+				if($gid>0)
+					$this->chars[$c] = $gid;
+			}
+		}
+	}
+
+	function ParseName()
+	{
+		$this->Seek('name');
+		$tableOffset = ftell($this->f);
+		$this->postScriptName = '';
+		$this->Skip(2); // format
+		$count = $this->ReadUShort();
+		$stringOffset = $this->ReadUShort();
+		for($i=0;$i<$count;$i++)
+		{
+			$this->Skip(3*2); // platformID, encodingID, languageID
+			$nameID = $this->ReadUShort();
+			$length = $this->ReadUShort();
+			$offset = $this->ReadUShort();
+			if($nameID==6)
+			{
+				// PostScript name
+				fseek($this->f, $tableOffset+$stringOffset+$offset, SEEK_SET);
+				$s = $this->Read($length);
+				$s = str_replace(chr(0), '', $s);
+				$s = preg_replace('|[ \[\](){}<>/%]|', '', $s);
+				$this->postScriptName = $s;
+				break;
+			}
+		}
+		if($this->postScriptName=='')
+			$this->Error('PostScript name not found');
+	}
+
+	function ParseOS2()
+	{
+		$this->Seek('OS/2');
+		$version = $this->ReadUShort();
+		$this->Skip(3*2); // xAvgCharWidth, usWeightClass, usWidthClass
+		$fsType = $this->ReadUShort();
+		$this->Embeddable = ($fsType!=2) && ($fsType & 0x200)==0;
+		$this->Skip(11*2+10+4*4+4);
+		$fsSelection = $this->ReadUShort();
+		$this->Bold = ($fsSelection & 32)!=0;
+		$this->Skip(2*2); // usFirstCharIndex, usLastCharIndex
+		$this->typoAscender = $this->ReadShort();
+		$this->typoDescender = $this->ReadShort();
+		if($version>=2)
+		{
+			$this->Skip(3*2+2*4+2);
+			$this->capHeight = $this->ReadShort();
+		}
+		else
+			$this->capHeight = 0;
+	}
+
+	function ParsePost()
+	{
+		$this->Seek('post');
+		$this->Skip(4); // version
+		$this->italicAngle = $this->ReadShort();
+		$this->Skip(2); // Skip decimal part
+		$this->underlinePosition = $this->ReadShort();
+		$this->underlineThickness = $this->ReadShort();
+		$this->isFixedPitch = ($this->ReadULong()!=0);
+	}
+
+	function Error($msg)
+	{
+		if(PHP_SAPI=='cli')
+			die("Error: $msg\n");
+		else
+			die("<b>Error</b>: $msg");
+	}
+
+	function Seek($tag)
+	{
+		if(!isset($this->tables[$tag]))
+			$this->Error('Table not found: '.$tag);
+		fseek($this->f, $this->tables[$tag], SEEK_SET);
+	}
+
+	function Skip($n)
+	{
+		fseek($this->f, $n, SEEK_CUR);
+	}
+
+	function Read($n)
+	{
+		return fread($this->f, $n);
+	}
+
+	function ReadUShort()
+	{
+		$a = unpack('nn', fread($this->f,2));
+		return $a['n'];
+	}
+
+	function ReadShort()
+	{
+		$a = unpack('nn', fread($this->f,2));
+		$v = $a['n'];
+		if($v>=0x8000)
+			$v -= 65536;
+		return $v;
+	}
+
+	function ReadULong()
+	{
+		$a = unpack('NN', fread($this->f,4));
+		return $a['N'];
+	}
+}
+?>
